<html>
<head>
<title>OGRE: Ogre::HardwarePixelBuffer Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1HardwarePixelBuffer.html">HardwarePixelBuffer</a></div>
<h1>Ogre::HardwarePixelBuffer Class Reference</h1><!-- doxytag: class="Ogre::HardwarePixelBuffer" --><!-- doxytag: inherits="Ogre::HardwareBuffer" -->Specialisation of <a class="el" href="classOgre_1_1HardwareBuffer.html" title="Abstract class defining common features of hardware buffers.">HardwareBuffer</a> for a pixel buffer.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreHardwarePixelBuffer_8h-source.html">OgreHardwarePixelBuffer.h</a>&gt;</code>
<p>
<div class="dynheader">
Inheritance diagram for Ogre::HardwarePixelBuffer:</div>
<div class="dynsection">
<center><font size="2">[<a href="graph_legend.html">legend</a>]</font></center></div>

<p>
<a href="classOgre_1_1HardwarePixelBuffer-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Types</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">enum &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630">Usage</a> { <br>
&nbsp;&nbsp;<a class="el" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec466306f26f67ab31d60248314c9c6c77c9edb">HBU_STATIC</a> =  1, 
<a class="el" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630bec61c14b13652a06566a79afd6f7518">HBU_DYNAMIC</a> =  2, 
<a class="el" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec466302fe20ff00e9acb928a2d9680f0c505e2">HBU_WRITE_ONLY</a> =  4, 
<a class="el" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630246699879ba7647973a2d8ed86acf76f">HBU_DISCARDABLE</a> =  8, 
<br>
&nbsp;&nbsp;<a class="el" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec466305ffbb339becd31435c5f616be4c28996">HBU_STATIC_WRITE_ONLY</a> =  5, 
<a class="el" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630a0c82d1b27d6cc04e4b5f6d47a22a74c">HBU_DYNAMIC_WRITE_ONLY</a> =  6, 
<a class="el" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec4663029ff2e0fd2b408359e84291b27282516">HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE</a> =  14
<br>
 }</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Enums describing buffer usage; not mutually exclusive.  <a href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">enum &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBuffer.html#ac34930556f611928ec9157c04bd1b0f">LockOptions</a> { <a class="el" href="classOgre_1_1HardwareBuffer.html#ac34930556f611928ec9157c04bd1b0fe11601d29cd56aad7ea7a1b23a688b0e">HBL_NORMAL</a>, 
<a class="el" href="classOgre_1_1HardwareBuffer.html#ac34930556f611928ec9157c04bd1b0f176ad39ac15fc0a6028d820a6fe228ae">HBL_DISCARD</a>, 
<a class="el" href="classOgre_1_1HardwareBuffer.html#ac34930556f611928ec9157c04bd1b0fa364c1511514cd4d7ee1e7092eb41288">HBL_READ_ONLY</a>, 
<a class="el" href="classOgre_1_1HardwareBuffer.html#ac34930556f611928ec9157c04bd1b0f32a2f7b1c3430cc9c3f0f665934d0c4a">HBL_NO_OVERWRITE</a>
 }</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Locking options.  <a href="classOgre_1_1HardwareBuffer.html#ac34930556f611928ec9157c04bd1b0f">More...</a><br></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#ea594b749202aa526553061deb76efe6">HardwarePixelBuffer</a> (size_t <a class="el" href="classOgre_1_1HardwarePixelBuffer.html#e466eb08ea0efefbf95ad43a86a32b87">mWidth</a>, size_t <a class="el" href="classOgre_1_1HardwarePixelBuffer.html#4522dfa65baed807835c35a5b550148a">mHeight</a>, size_t <a class="el" href="classOgre_1_1HardwarePixelBuffer.html#65904db26e2e488f9a5648159dab0cdd">mDepth</a>, <a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> <a class="el" href="classOgre_1_1HardwarePixelBuffer.html#715786c17620c4705b5caefa6b2cb2df">mFormat</a>, <a class="el" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630">HardwareBuffer::Usage</a> usage, bool useSystemMemory, bool useShadowBuffer)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Should be called by <a class="el" href="classOgre_1_1HardwareBufferManager.html" title="Abstract singleton class for managing hardware buffers, a concrete instance of this...">HardwareBufferManager</a>.  <a href="#ea594b749202aa526553061deb76efe6"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#013a4bfeb913fb485db026e214bdd6f6">~HardwarePixelBuffer</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual const <a class="el" href="classOgre_1_1PixelBox.html">PixelBox</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#98181701e387658963d0739984499fb3">lock</a> (const <a class="el" href="structOgre_1_1Box.html">Image::Box</a> &amp;lockBox, <a class="el" href="classOgre_1_1HardwareBuffer.html#ac34930556f611928ec9157c04bd1b0f">LockOptions</a> options)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Lock the buffer for (potentially) reading / writing.  <a href="#98181701e387658963d0739984499fb3"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#8aaa214f42a683f7203ed42f8c0caf17">lock</a> (size_t offset, size_t length, <a class="el" href="classOgre_1_1HardwareBuffer.html#ac34930556f611928ec9157c04bd1b0f">LockOptions</a> options)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Lock the buffer for (potentially) reading / writing. <p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>offset</em>&nbsp;</td><td>The byte offset from the start of the buffer to lock </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>length</em>&nbsp;</td><td>The size of the area to lock, in bytes </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>options</em>&nbsp;</td><td>Locking options </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>Pointer to the locked memory </dd></dl>
  <a href="#8aaa214f42a683f7203ed42f8c0caf17"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">const <a class="el" href="classOgre_1_1PixelBox.html">PixelBox</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#9f888e279109a05b5228f71c5b8f9d34">getCurrentLock</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the current locked region.  <a href="#9f888e279109a05b5228f71c5b8f9d34"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#bbd6dece7babe2473adc396bb458f53c">readData</a> (size_t offset, size_t length, void *pDest)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Reads data from the buffer and places it in the memory pointed to by pDest. <p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>offset</em>&nbsp;</td><td>The byte offset from the start of the buffer to read </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>length</em>&nbsp;</td><td>The size of the area to read, in bytes </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>pDest</em>&nbsp;</td><td>The area of memory in which to place the data, must be large enough to accommodate the data! </td></tr>
  </table>
</dl>
  <a href="#bbd6dece7babe2473adc396bb458f53c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#117ff90e202f525c2a4b7bb9c51eb4df">writeData</a> (size_t offset, size_t length, const void *pSource, bool discardWholeBuffer=false)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Writes data to the buffer from an area of system memory; note that you must ensure that your buffer is big enough. <p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>offset</em>&nbsp;</td><td>The byte offset from the start of the buffer to start writing </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>length</em>&nbsp;</td><td>The size of the data to write to, in bytes </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>pSource</em>&nbsp;</td><td>The source of the data to be written </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>discardWholeBuffer</em>&nbsp;</td><td>If true, this allows the driver to discard the entire buffer when writing, such that DMA stalls can be avoided; use if you can. </td></tr>
  </table>
</dl>
  <a href="#117ff90e202f525c2a4b7bb9c51eb4df"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#fa8ebd4831c5e9a5538c486581d01ab0">blit</a> (const <a class="el" href="classOgre_1_1HardwarePixelBufferSharedPtr.html">HardwarePixelBufferSharedPtr</a> &amp;src, const <a class="el" href="structOgre_1_1Box.html">Image::Box</a> &amp;srcBox, const <a class="el" href="structOgre_1_1Box.html">Image::Box</a> &amp;dstBox)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Copies a box from another PixelBuffer to a region of the this PixelBuffer.  <a href="#fa8ebd4831c5e9a5538c486581d01ab0"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#d4a77bfe5a38c59300124e6cf6305b9e">blit</a> (const <a class="el" href="classOgre_1_1HardwarePixelBufferSharedPtr.html">HardwarePixelBufferSharedPtr</a> &amp;src)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Convience function that blits the entire source pixel buffer to this buffer.  <a href="#d4a77bfe5a38c59300124e6cf6305b9e"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#56f6a6f97236e909f4fdeeab98f92492">blitFromMemory</a> (const <a class="el" href="classOgre_1_1PixelBox.html">PixelBox</a> &amp;src, const <a class="el" href="structOgre_1_1Box.html">Image::Box</a> &amp;dstBox)=0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Copies a region from normal memory to a region of this pixelbuffer.  <a href="#56f6a6f97236e909f4fdeeab98f92492"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#2405dade15f595710a02903d302155bd">blitFromMemory</a> (const <a class="el" href="classOgre_1_1PixelBox.html">PixelBox</a> &amp;src)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Convience function that blits a pixelbox from memory to the entire buffer.  <a href="#2405dade15f595710a02903d302155bd"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#d3587fff7004002a93541b533e95e6ee">blitToMemory</a> (const <a class="el" href="structOgre_1_1Box.html">Image::Box</a> &amp;srcBox, const <a class="el" href="classOgre_1_1PixelBox.html">PixelBox</a> &amp;dst)=0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Copies a region of this pixelbuffer to normal memory.  <a href="#d3587fff7004002a93541b533e95e6ee"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#3d9ff2acd7776be35efd6fa24307012c">blitToMemory</a> (const <a class="el" href="classOgre_1_1PixelBox.html">PixelBox</a> &amp;dst)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Convience function that blits this entire buffer to a pixelbox.  <a href="#3d9ff2acd7776be35efd6fa24307012c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <a class="el" href="classOgre_1_1RenderTexture.html">RenderTexture</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#adcc10954fe5d710eb8cde1ebf0082a3">getRenderTarget</a> (size_t slice=0)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get a render target for this PixelBuffer, or a slice of it.  <a href="#adcc10954fe5d710eb8cde1ebf0082a3"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#bda31825eaf2b34edec2d0920c949e30">getWidth</a> () const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets the width of this buffer.  <a href="#bda31825eaf2b34edec2d0920c949e30"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#1a86fb9153a28f146a12c8db65ede66c">getHeight</a> () const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets the height of this buffer.  <a href="#1a86fb9153a28f146a12c8db65ede66c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#e6d2727151ff4574b70e3459aecf7faf">getDepth</a> () const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets the depth of this buffer.  <a href="#e6d2727151ff4574b70e3459aecf7faf"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#ee72f3e84af166ef031659478fea1967">getFormat</a> () const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets the native pixel format of this buffer.  <a href="#ee72f3e84af166ef031659478fea1967"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBuffer.html#93b204642190e611bc226ea08d29160e">lock</a> (<a class="el" href="classOgre_1_1HardwareBuffer.html#ac34930556f611928ec9157c04bd1b0f">LockOptions</a> options)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Lock the entire buffer for (potentially) reading / writing.  <a href="#93b204642190e611bc226ea08d29160e"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBuffer.html#64ddd429ff2c8ac4f0cca5decb5c6757">unlock</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Releases the lock on this buffer.  <a href="#64ddd429ff2c8ac4f0cca5decb5c6757"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBuffer.html#721891f0c0bd391dd5848c8a585ba054">copyData</a> (<a class="el" href="classOgre_1_1HardwareBuffer.html">HardwareBuffer</a> &amp;srcBuffer, size_t srcOffset, size_t dstOffset, size_t length, bool discardWholeBuffer=false)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Copy data from another buffer into this one.  <a href="#721891f0c0bd391dd5848c8a585ba054"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBuffer.html#344c52f2214eaff097d5fbc390e7684b">_updateFromShadow</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Updates the real buffer from the shadow buffer, if required.  <a href="#344c52f2214eaff097d5fbc390e7684b"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBuffer.html#1b1b5faf06139040824fd989d0b279f8">getSizeInBytes</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the size of this buffer in bytes.  <a href="#1b1b5faf06139040824fd989d0b279f8"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630">Usage</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBuffer.html#0e00770f5e9395e41b6520be8421a6c8">getUsage</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the Usage flags with which this buffer was created.  <a href="#0e00770f5e9395e41b6520be8421a6c8"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBuffer.html#61086322fba08abadf4fe6734a7c70f7">isSystemMemory</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns whether this buffer is held in system memory.  <a href="#61086322fba08abadf4fe6734a7c70f7"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBuffer.html#d523887cfaa6abe48dd494a3ea06805a">hasShadowBuffer</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns whether this buffer has a system memory shadow for quicker reading.  <a href="#d523887cfaa6abe48dd494a3ea06805a"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBuffer.html#3d5a62cbd76fc2ecd4e1a540bac5f9bc">isLocked</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns whether or not this buffer is currently locked.  <a href="#3d5a62cbd76fc2ecd4e1a540bac5f9bc"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBuffer.html#688e1be4a913099ce5e06172771e2d45">suppressHardwareUpdate</a> (bool suppress)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight"><a class="el" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a> true to suppress hardware upload of shadow buffer changes.  <a href="#688e1be4a913099ce5e06172771e2d45"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <a class="el" href="classOgre_1_1PixelBox.html">PixelBox</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#7f1dffbd05953facc61166cb7ad5066c">lockImpl</a> (const <a class="el" href="structOgre_1_1Box.html">Image::Box</a> lockBox, <a class="el" href="classOgre_1_1HardwareBuffer.html#ac34930556f611928ec9157c04bd1b0f">LockOptions</a> options)=0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal implementation of <a class="el" href="classOgre_1_1HardwarePixelBuffer.html#98181701e387658963d0739984499fb3" title="Lock the buffer for (potentially) reading / writing.">lock()</a>, must be overridden in subclasses.  <a href="#7f1dffbd05953facc61166cb7ad5066c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#6ab419f1f901d58230f76ad844636be4">lockImpl</a> (size_t offset, size_t length, <a class="el" href="classOgre_1_1HardwareBuffer.html#ac34930556f611928ec9157c04bd1b0f">LockOptions</a> options)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal implementation of <a class="el" href="classOgre_1_1HardwarePixelBuffer.html#98181701e387658963d0739984499fb3" title="Lock the buffer for (potentially) reading / writing.">lock()</a>, do not OVERRIDE or CALL this for <a class="el" href="classOgre_1_1HardwarePixelBuffer.html" title="Specialisation of HardwareBuffer for a pixel buffer.">HardwarePixelBuffer</a> implementations, but override the previous method.  <a href="#6ab419f1f901d58230f76ad844636be4"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#b665898dc70e35c3c16165c62206f3ab">_clearSliceRTT</a> (size_t zoffset)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal implementation of <a class="el" href="classOgre_1_1HardwareBuffer.html#64ddd429ff2c8ac4f0cca5decb5c6757" title="Releases the lock on this buffer.">unlock()</a>, must be overridden in subclasses.  <a href="#b665898dc70e35c3c16165c62206f3ab"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBuffer.html#82ec5566379a4c76fea8b68d55ee9d6f">unlockImpl</a> (void)=0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal implementation of <a class="el" href="classOgre_1_1HardwareBuffer.html#64ddd429ff2c8ac4f0cca5decb5c6757" title="Releases the lock on this buffer.">unlock()</a>.  <a href="#82ec5566379a4c76fea8b68d55ee9d6f"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#e466eb08ea0efefbf95ad43a86a32b87">mWidth</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#4522dfa65baed807835c35a5b550148a">mHeight</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#65904db26e2e488f9a5648159dab0cdd">mDepth</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#0a0a98e600dfa4b15778b6bcb30acb70">mRowPitch</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#cae5b713a65e3d0d5881ae02b3318d34">mSlicePitch</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#715786c17620c4705b5caefa6b2cb2df">mFormat</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1PixelBox.html">PixelBox</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#811656bfdacc1339fcba481c4bd8f6d1">mCurrentLock</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBuffer.html#a8fecea9221ffacaae2f1fdea38558da">mSizeInBytes</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630">Usage</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBuffer.html#2eb83f024781415a7fefb31f65a255c2">mUsage</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBuffer.html#25edb91791e48a7cc9ba2fb05f11bd33">mIsLocked</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBuffer.html#272cf9751affd73ea03930153357930b">mLockStart</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBuffer.html#c96a7a04f4e29d8d00117a80d9a1c9a0">mLockSize</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBuffer.html#f97b321278124803d13b700a46657ecb">mSystemMemory</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBuffer.html#2caed02d4c9ad400d020ea8b0b24adf4">mUseShadowBuffer</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1HardwareBuffer.html">HardwareBuffer</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBuffer.html#01ef9e872aec8bb74b75be1aff787c8f">mpShadowBuffer</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBuffer.html#68127e87e132304c7655df554a82110c">mShadowUpdated</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwareBuffer.html#47e53af2e87624c42ab934766bf65fca">mSuppressHardwareUpdate</a></td></tr>

<tr><td colspan="2"><br><h2>Friends</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">class&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1HardwarePixelBuffer.html#2548fc9744f5e43e0276d5627ca178de">RenderTexture</a></td></tr>

</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Specialisation of <a class="el" href="classOgre_1_1HardwareBuffer.html" title="Abstract class defining common features of hardware buffers.">HardwareBuffer</a> for a pixel buffer. 
<p>
The HardwarePixelbuffer abstracts an 1D, 2D or 3D quantity of pixels stored by the rendering API. The buffer can be located on the card or in main memory depending on its usage. One mipmap level of a texture is an example of a <a class="el" href="classOgre_1_1HardwarePixelBuffer.html" title="Specialisation of HardwareBuffer for a pixel buffer.">HardwarePixelBuffer</a>. 
<p>Definition at line <a class="el" href="OgreHardwarePixelBuffer_8h-source.html#l00047">47</a> of file <a class="el" href="OgreHardwarePixelBuffer_8h-source.html">OgreHardwarePixelBuffer.h</a>.</p>
<hr><h2>Member Enumeration Documentation</h2>
<a class="anchor" name="e51f5970d879af736e4cf53e1ec46630"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::Usage" ref="e51f5970d879af736e4cf53e1ec46630" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630">Ogre::HardwareBuffer::Usage</a><code> [inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Enums describing buffer usage; not mutually exclusive. 
<p>
<dl compact><dt><b>Enumerator: </b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td valign="top"><em><a class="anchor" name="e51f5970d879af736e4cf53e1ec466306f26f67ab31d60248314c9c6c77c9edb"></a><!-- doxytag: member="HBU_STATIC" ref="e51f5970d879af736e4cf53e1ec466306f26f67ab31d60248314c9c6c77c9edb" args="" -->HBU_STATIC</em>&nbsp;</td><td>
Static buffer which the application rarely modifies once created. 
<p>
Modifying the contents of this buffer will involve a performance hit. </td></tr>
<tr><td valign="top"><em><a class="anchor" name="e51f5970d879af736e4cf53e1ec46630bec61c14b13652a06566a79afd6f7518"></a><!-- doxytag: member="HBU_DYNAMIC" ref="e51f5970d879af736e4cf53e1ec46630bec61c14b13652a06566a79afd6f7518" args="" -->HBU_DYNAMIC</em>&nbsp;</td><td>
Indicates the application would like to modify this buffer with the CPU fairly often. 
<p>
Buffers created with this flag will typically end up in AGP memory rather than video memory. </td></tr>
<tr><td valign="top"><em><a class="anchor" name="e51f5970d879af736e4cf53e1ec466302fe20ff00e9acb928a2d9680f0c505e2"></a><!-- doxytag: member="HBU_WRITE_ONLY" ref="e51f5970d879af736e4cf53e1ec466302fe20ff00e9acb928a2d9680f0c505e2" args="" -->HBU_WRITE_ONLY</em>&nbsp;</td><td>
Indicates the application will never read the contents of the buffer back, it will only ever write data. 
<p>
Locking a buffer with this flag will ALWAYS return a pointer to new, blank memory rather than the memory associated with the contents of the buffer; this avoids DMA stalls because you can write to a new memory area while the previous one is being used. </td></tr>
<tr><td valign="top"><em><a class="anchor" name="e51f5970d879af736e4cf53e1ec46630246699879ba7647973a2d8ed86acf76f"></a><!-- doxytag: member="HBU_DISCARDABLE" ref="e51f5970d879af736e4cf53e1ec46630246699879ba7647973a2d8ed86acf76f" args="" -->HBU_DISCARDABLE</em>&nbsp;</td><td>
Indicates that the application will be refilling the contents of the buffer regularly (not just updating, but generating the contents from scratch), and therefore does not mind if the contents of the buffer are lost somehow and need to be recreated. 
<p>
This allows and additional level of optimisation on the buffer. This option only really makes sense when combined with HBU_DYNAMIC_WRITE_ONLY. </td></tr>
<tr><td valign="top"><em><a class="anchor" name="e51f5970d879af736e4cf53e1ec466305ffbb339becd31435c5f616be4c28996"></a><!-- doxytag: member="HBU_STATIC_WRITE_ONLY" ref="e51f5970d879af736e4cf53e1ec466305ffbb339becd31435c5f616be4c28996" args="" -->HBU_STATIC_WRITE_ONLY</em>&nbsp;</td><td>
Combination of HBU_STATIC and HBU_WRITE_ONLY. </td></tr>
<tr><td valign="top"><em><a class="anchor" name="e51f5970d879af736e4cf53e1ec46630a0c82d1b27d6cc04e4b5f6d47a22a74c"></a><!-- doxytag: member="HBU_DYNAMIC_WRITE_ONLY" ref="e51f5970d879af736e4cf53e1ec46630a0c82d1b27d6cc04e4b5f6d47a22a74c" args="" -->HBU_DYNAMIC_WRITE_ONLY</em>&nbsp;</td><td>
Combination of HBU_DYNAMIC and HBU_WRITE_ONLY. 
<p>
If you use this, strongly consider using HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE instead if you update the entire contents of the buffer very regularly. </td></tr>
<tr><td valign="top"><em><a class="anchor" name="e51f5970d879af736e4cf53e1ec4663029ff2e0fd2b408359e84291b27282516"></a><!-- doxytag: member="HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE" ref="e51f5970d879af736e4cf53e1ec4663029ff2e0fd2b408359e84291b27282516" args="" -->HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE</em>&nbsp;</td><td>
Combination of HBU_DYNAMIC, HBU_WRITE_ONLY and HBU_DISCARDABLE. </td></tr>
</table>
</dl>

<p>Definition at line <a class="el" href="OgreHardwareBuffer_8h-source.html#l00073">73</a> of file <a class="el" href="OgreHardwareBuffer_8h-source.html">OgreHardwareBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="ac34930556f611928ec9157c04bd1b0f"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::LockOptions" ref="ac34930556f611928ec9157c04bd1b0f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="classOgre_1_1HardwareBuffer.html#ac34930556f611928ec9157c04bd1b0f">Ogre::HardwareBuffer::LockOptions</a><code> [inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Locking options. 
<p>
<dl compact><dt><b>Enumerator: </b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td valign="top"><em><a class="anchor" name="ac34930556f611928ec9157c04bd1b0fe11601d29cd56aad7ea7a1b23a688b0e"></a><!-- doxytag: member="HBL_NORMAL" ref="ac34930556f611928ec9157c04bd1b0fe11601d29cd56aad7ea7a1b23a688b0e" args="" -->HBL_NORMAL</em>&nbsp;</td><td>
Normal mode, ie allows read/write and contents are preserved. 
<p>
</td></tr>
<tr><td valign="top"><em><a class="anchor" name="ac34930556f611928ec9157c04bd1b0f176ad39ac15fc0a6028d820a6fe228ae"></a><!-- doxytag: member="HBL_DISCARD" ref="ac34930556f611928ec9157c04bd1b0f176ad39ac15fc0a6028d820a6fe228ae" args="" -->HBL_DISCARD</em>&nbsp;</td><td>
Discards the <em>entire</em> buffer while locking; this allows optimisation to be performed because synchronisation issues are relaxed. 
<p>
Only allowed on buffers created with the HBU_DYNAMIC flag. </td></tr>
<tr><td valign="top"><em><a class="anchor" name="ac34930556f611928ec9157c04bd1b0fa364c1511514cd4d7ee1e7092eb41288"></a><!-- doxytag: member="HBL_READ_ONLY" ref="ac34930556f611928ec9157c04bd1b0fa364c1511514cd4d7ee1e7092eb41288" args="" -->HBL_READ_ONLY</em>&nbsp;</td><td>
Lock the buffer for reading only. 
<p>
Not allowed in buffers which are created with HBU_WRITE_ONLY. Mandatory on statuc buffers, ie those created without the HBU_DYNAMIC flag. </td></tr>
<tr><td valign="top"><em><a class="anchor" name="ac34930556f611928ec9157c04bd1b0f32a2f7b1c3430cc9c3f0f665934d0c4a"></a><!-- doxytag: member="HBL_NO_OVERWRITE" ref="ac34930556f611928ec9157c04bd1b0f32a2f7b1c3430cc9c3f0f665934d0c4a" args="" -->HBL_NO_OVERWRITE</em>&nbsp;</td><td>
As HBL_NORMAL, except the application guarantees not to overwrite any region of the buffer which has already been used in this frame, can allow some optimisation on some APIs. 
<p>
</td></tr>
</table>
</dl>

<p>Definition at line <a class="el" href="OgreHardwareBuffer_8h-source.html#l00115">115</a> of file <a class="el" href="OgreHardwareBuffer_8h-source.html">OgreHardwareBuffer.h</a>.</p>

</div>
</div><p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="ea594b749202aa526553061deb76efe6"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::HardwarePixelBuffer" ref="ea594b749202aa526553061deb76efe6" args="(size_t mWidth, size_t mHeight, size_t mDepth, PixelFormat mFormat, HardwareBuffer::Usage usage, bool useSystemMemory, bool useShadowBuffer)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::HardwarePixelBuffer::HardwarePixelBuffer           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>mWidth</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>mHeight</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>mDepth</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&nbsp;</td>
          <td class="paramname"> <em>mFormat</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630">HardwareBuffer::Usage</a>&nbsp;</td>
          <td class="paramname"> <em>usage</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>useSystemMemory</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>useShadowBuffer</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Should be called by <a class="el" href="classOgre_1_1HardwareBufferManager.html" title="Abstract singleton class for managing hardware buffers, a concrete instance of this...">HardwareBufferManager</a>. 
<p>

</div>
</div><p>
<a class="anchor" name="013a4bfeb913fb485db026e214bdd6f6"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::~HardwarePixelBuffer" ref="013a4bfeb913fb485db026e214bdd6f6" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::HardwarePixelBuffer::~HardwarePixelBuffer           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="7f1dffbd05953facc61166cb7ad5066c"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::lockImpl" ref="7f1dffbd05953facc61166cb7ad5066c" args="(const Image::Box lockBox, LockOptions options)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1PixelBox.html">PixelBox</a> Ogre::HardwarePixelBuffer::lockImpl           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="structOgre_1_1Box.html">Image::Box</a>&nbsp;</td>
          <td class="paramname"> <em>lockBox</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareBuffer.html#ac34930556f611928ec9157c04bd1b0f">LockOptions</a>&nbsp;</td>
          <td class="paramname"> <em>options</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [protected, pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal implementation of <a class="el" href="classOgre_1_1HardwarePixelBuffer.html#98181701e387658963d0739984499fb3" title="Lock the buffer for (potentially) reading / writing.">lock()</a>, must be overridden in subclasses. 
<p>

</div>
</div><p>
<a class="anchor" name="6ab419f1f901d58230f76ad844636be4"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::lockImpl" ref="6ab419f1f901d58230f76ad844636be4" args="(size_t offset, size_t length, LockOptions options)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void* Ogre::HardwarePixelBuffer::lockImpl           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>offset</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>length</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareBuffer.html#ac34930556f611928ec9157c04bd1b0f">LockOptions</a>&nbsp;</td>
          <td class="paramname"> <em>options</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal implementation of <a class="el" href="classOgre_1_1HardwarePixelBuffer.html#98181701e387658963d0739984499fb3" title="Lock the buffer for (potentially) reading / writing.">lock()</a>, do not OVERRIDE or CALL this for <a class="el" href="classOgre_1_1HardwarePixelBuffer.html" title="Specialisation of HardwareBuffer for a pixel buffer.">HardwarePixelBuffer</a> implementations, but override the previous method. 
<p>

<p>Implements <a class="el" href="classOgre_1_1HardwareBuffer.html#59021d471dfa4598bd1a98d6982ac558">Ogre::HardwareBuffer</a>.</p>

</div>
</div><p>
<a class="anchor" name="b665898dc70e35c3c16165c62206f3ab"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::_clearSliceRTT" ref="b665898dc70e35c3c16165c62206f3ab" args="(size_t zoffset)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::HardwarePixelBuffer::_clearSliceRTT           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>zoffset</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal implementation of <a class="el" href="classOgre_1_1HardwareBuffer.html#64ddd429ff2c8ac4f0cca5decb5c6757" title="Releases the lock on this buffer.">unlock()</a>, must be overridden in subclasses. 
<p>
Notify TextureBuffer of destruction of render target. Called by <a class="el" href="classOgre_1_1RenderTexture.html" title="This class represents a RenderTarget that renders to a Texture.">RenderTexture</a> when destroyed. 
</div>
</div><p>
<a class="anchor" name="98181701e387658963d0739984499fb3"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::lock" ref="98181701e387658963d0739984499fb3" args="(const Image::Box &amp;lockBox, LockOptions options)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="classOgre_1_1PixelBox.html">PixelBox</a>&amp; Ogre::HardwarePixelBuffer::lock           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="structOgre_1_1Box.html">Image::Box</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>lockBox</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareBuffer.html#ac34930556f611928ec9157c04bd1b0f">LockOptions</a>&nbsp;</td>
          <td class="paramname"> <em>options</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Lock the buffer for (potentially) reading / writing. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>lockBox</em>&nbsp;</td><td>Region of the buffer to lock </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>options</em>&nbsp;</td><td>Locking options </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd><a class="el" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory...">PixelBox</a> containing the locked region, the pitches and the pixel format </dd></dl>

</div>
</div><p>
<a class="anchor" name="8aaa214f42a683f7203ed42f8c0caf17"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::lock" ref="8aaa214f42a683f7203ed42f8c0caf17" args="(size_t offset, size_t length, LockOptions options)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void* Ogre::HardwarePixelBuffer::lock           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>offset</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>length</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareBuffer.html#ac34930556f611928ec9157c04bd1b0f">LockOptions</a>&nbsp;</td>
          <td class="paramname"> <em>options</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Lock the buffer for (potentially) reading / writing. <p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>offset</em>&nbsp;</td><td>The byte offset from the start of the buffer to lock </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>length</em>&nbsp;</td><td>The size of the area to lock, in bytes </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>options</em>&nbsp;</td><td>Locking options </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>Pointer to the locked memory </dd></dl>
 
<p>

<p>Reimplemented from <a class="el" href="classOgre_1_1HardwareBuffer.html#b1caebda1f7442706df97531c2d90aaf">Ogre::HardwareBuffer</a>.</p>

</div>
</div><p>
<a class="anchor" name="9f888e279109a05b5228f71c5b8f9d34"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::getCurrentLock" ref="9f888e279109a05b5228f71c5b8f9d34" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1PixelBox.html">PixelBox</a>&amp; Ogre::HardwarePixelBuffer::getCurrentLock           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Get the current locked region. 
<p>
This is the same value as returned by lock(const Image::Box, LockOptions) <dl class="return" compact><dt><b>Returns:</b></dt><dd><a class="el" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory...">PixelBox</a> containing the locked region </dd></dl>

</div>
</div><p>
<a class="anchor" name="bbd6dece7babe2473adc396bb458f53c"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::readData" ref="bbd6dece7babe2473adc396bb458f53c" args="(size_t offset, size_t length, void *pDest)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::HardwarePixelBuffer::readData           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>offset</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>length</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>pDest</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Reads data from the buffer and places it in the memory pointed to by pDest. <p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>offset</em>&nbsp;</td><td>The byte offset from the start of the buffer to read </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>length</em>&nbsp;</td><td>The size of the area to read, in bytes </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>pDest</em>&nbsp;</td><td>The area of memory in which to place the data, must be large enough to accommodate the data! </td></tr>
  </table>
</dl>
 
<p>

<p>Implements <a class="el" href="classOgre_1_1HardwareBuffer.html#552f466b57ba77f29e083266d4688765">Ogre::HardwareBuffer</a>.</p>

</div>
</div><p>
<a class="anchor" name="117ff90e202f525c2a4b7bb9c51eb4df"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::writeData" ref="117ff90e202f525c2a4b7bb9c51eb4df" args="(size_t offset, size_t length, const void *pSource, bool discardWholeBuffer=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::HardwarePixelBuffer::writeData           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>offset</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>length</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const void *&nbsp;</td>
          <td class="paramname"> <em>pSource</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>discardWholeBuffer</em> = <code>false</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Writes data to the buffer from an area of system memory; note that you must ensure that your buffer is big enough. <p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>offset</em>&nbsp;</td><td>The byte offset from the start of the buffer to start writing </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>length</em>&nbsp;</td><td>The size of the data to write to, in bytes </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>pSource</em>&nbsp;</td><td>The source of the data to be written </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>discardWholeBuffer</em>&nbsp;</td><td>If true, this allows the driver to discard the entire buffer when writing, such that DMA stalls can be avoided; use if you can. </td></tr>
  </table>
</dl>
 
<p>

<p>Implements <a class="el" href="classOgre_1_1HardwareBuffer.html#8c313688a0df3c28a36738c31fcbc3ee">Ogre::HardwareBuffer</a>.</p>

</div>
</div><p>
<a class="anchor" name="fa8ebd4831c5e9a5538c486581d01ab0"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::blit" ref="fa8ebd4831c5e9a5538c486581d01ab0" args="(const HardwarePixelBufferSharedPtr &amp;src, const Image::Box &amp;srcBox, const Image::Box &amp;dstBox)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::HardwarePixelBuffer::blit           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1HardwarePixelBufferSharedPtr.html">HardwarePixelBufferSharedPtr</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="structOgre_1_1Box.html">Image::Box</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>srcBox</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="structOgre_1_1Box.html">Image::Box</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>dstBox</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Copies a box from another PixelBuffer to a region of the this PixelBuffer. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>dst</em>&nbsp;</td><td>Source pixel buffer </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>srcBox</em>&nbsp;</td><td><a class="el" href="classOgre_1_1Image.html#bd443d16124b2b012b77a282f2af909a">Image::Box</a> describing the source region in src </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>dstBox</em>&nbsp;</td><td><a class="el" href="classOgre_1_1Image.html#bd443d16124b2b012b77a282f2af909a">Image::Box</a> describing the destination region in this buffer </td></tr>
  </table>
</dl>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>The source and destination regions dimensions don't have to match, in which case scaling is done. This scaling is generally done using a bilinear filter in hardware, but it is faster to pass the source image in the right dimensions. </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>Only call this function when both buffers are unlocked. </dd></dl>

</div>
</div><p>
<a class="anchor" name="d4a77bfe5a38c59300124e6cf6305b9e"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::blit" ref="d4a77bfe5a38c59300124e6cf6305b9e" args="(const HardwarePixelBufferSharedPtr &amp;src)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::HardwarePixelBuffer::blit           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1HardwarePixelBufferSharedPtr.html">HardwarePixelBufferSharedPtr</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>src</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Convience function that blits the entire source pixel buffer to this buffer. 
<p>
If source and destination dimensions don't match, scaling is done. <dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>src</em>&nbsp;</td><td><a class="el" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory...">PixelBox</a> containing the source pixels and format in memory </td></tr>
  </table>
</dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>Only call this function when the buffer is unlocked. </dd></dl>

</div>
</div><p>
<a class="anchor" name="56f6a6f97236e909f4fdeeab98f92492"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::blitFromMemory" ref="56f6a6f97236e909f4fdeeab98f92492" args="(const PixelBox &amp;src, const Image::Box &amp;dstBox)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::HardwarePixelBuffer::blitFromMemory           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1PixelBox.html">PixelBox</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="structOgre_1_1Box.html">Image::Box</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>dstBox</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Copies a region from normal memory to a region of this pixelbuffer. 
<p>
The source image can be in any pixel format supported by OGRE, and in any size. <dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>src</em>&nbsp;</td><td><a class="el" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory...">PixelBox</a> containing the source pixels and format in memory </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>dstBox</em>&nbsp;</td><td><a class="el" href="classOgre_1_1Image.html#bd443d16124b2b012b77a282f2af909a">Image::Box</a> describing the destination region in this buffer </td></tr>
  </table>
</dl>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>The source and destination regions dimensions don't have to match, in which case scaling is done. This scaling is generally done using a bilinear filter in hardware, but it is faster to pass the source image in the right dimensions. </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>Only call this function when the buffer is unlocked. </dd></dl>

</div>
</div><p>
<a class="anchor" name="2405dade15f595710a02903d302155bd"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::blitFromMemory" ref="2405dade15f595710a02903d302155bd" args="(const PixelBox &amp;src)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::HardwarePixelBuffer::blitFromMemory           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1PixelBox.html">PixelBox</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>src</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Convience function that blits a pixelbox from memory to the entire buffer. 
<p>
The source image is scaled as needed. <dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>src</em>&nbsp;</td><td><a class="el" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory...">PixelBox</a> containing the source pixels and format in memory </td></tr>
  </table>
</dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>Only call this function when the buffer is unlocked. </dd></dl>

<p>Definition at line <a class="el" href="OgreHardwarePixelBuffer_8h-source.html#l00143">143</a> of file <a class="el" href="OgreHardwarePixelBuffer_8h-source.html">OgreHardwarePixelBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="d3587fff7004002a93541b533e95e6ee"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::blitToMemory" ref="d3587fff7004002a93541b533e95e6ee" args="(const Image::Box &amp;srcBox, const PixelBox &amp;dst)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::HardwarePixelBuffer::blitToMemory           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="structOgre_1_1Box.html">Image::Box</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>srcBox</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1PixelBox.html">PixelBox</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>dst</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Copies a region of this pixelbuffer to normal memory. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>srcBox</em>&nbsp;</td><td><a class="el" href="classOgre_1_1Image.html#bd443d16124b2b012b77a282f2af909a">Image::Box</a> describing the source region of this buffer </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>dst</em>&nbsp;</td><td><a class="el" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory...">PixelBox</a> describing the destination pixels and format in memory </td></tr>
  </table>
</dl>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>The source and destination regions don't have to match, in which case scaling is done. </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>Only call this function when the buffer is unlocked. </dd></dl>

</div>
</div><p>
<a class="anchor" name="3d9ff2acd7776be35efd6fa24307012c"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::blitToMemory" ref="3d9ff2acd7776be35efd6fa24307012c" args="(const PixelBox &amp;dst)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::HardwarePixelBuffer::blitToMemory           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1PixelBox.html">PixelBox</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>dst</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Convience function that blits this entire buffer to a pixelbox. 
<p>
The image is scaled as needed. <dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>src</em>&nbsp;</td><td><a class="el" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory...">PixelBox</a> containing the source pixels and format in memory </td></tr>
  </table>
</dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>Only call this function when the buffer is unlocked. </dd></dl>

<p>Definition at line <a class="el" href="OgreHardwarePixelBuffer_8h-source.html#l00162">162</a> of file <a class="el" href="OgreHardwarePixelBuffer_8h-source.html">OgreHardwarePixelBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="adcc10954fe5d710eb8cde1ebf0082a3"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::getRenderTarget" ref="adcc10954fe5d710eb8cde1ebf0082a3" args="(size_t slice=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1RenderTexture.html">RenderTexture</a>* Ogre::HardwarePixelBuffer::getRenderTarget           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>slice</em> = <code>0</code>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Get a render target for this PixelBuffer, or a slice of it. 
<p>
The texture this was acquired from must have TU_RENDERTARGET set, otherwise it is possible to render to it and this method will throw an ERR_RENDERSYSTEM exception. <dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>slice</em>&nbsp;</td><td>Which slice </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>A pointer to the render target. This pointer has the lifespan of this PixelBuffer. </dd></dl>

</div>
</div><p>
<a class="anchor" name="bda31825eaf2b34edec2d0920c949e30"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::getWidth" ref="bda31825eaf2b34edec2d0920c949e30" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t Ogre::HardwarePixelBuffer::getWidth           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets the width of this buffer. 
<p>

<p>Definition at line <a class="el" href="OgreHardwarePixelBuffer_8h-source.html#l00177">177</a> of file <a class="el" href="OgreHardwarePixelBuffer_8h-source.html">OgreHardwarePixelBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="1a86fb9153a28f146a12c8db65ede66c"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::getHeight" ref="1a86fb9153a28f146a12c8db65ede66c" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t Ogre::HardwarePixelBuffer::getHeight           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets the height of this buffer. 
<p>

<p>Definition at line <a class="el" href="OgreHardwarePixelBuffer_8h-source.html#l00179">179</a> of file <a class="el" href="OgreHardwarePixelBuffer_8h-source.html">OgreHardwarePixelBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="e6d2727151ff4574b70e3459aecf7faf"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::getDepth" ref="e6d2727151ff4574b70e3459aecf7faf" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t Ogre::HardwarePixelBuffer::getDepth           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets the depth of this buffer. 
<p>

<p>Definition at line <a class="el" href="OgreHardwarePixelBuffer_8h-source.html#l00181">181</a> of file <a class="el" href="OgreHardwarePixelBuffer_8h-source.html">OgreHardwarePixelBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="ee72f3e84af166ef031659478fea1967"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::getFormat" ref="ee72f3e84af166ef031659478fea1967" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> Ogre::HardwarePixelBuffer::getFormat           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets the native pixel format of this buffer. 
<p>

<p>Definition at line <a class="el" href="OgreHardwarePixelBuffer_8h-source.html#l00183">183</a> of file <a class="el" href="OgreHardwarePixelBuffer_8h-source.html">OgreHardwarePixelBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="82ec5566379a4c76fea8b68d55ee9d6f"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::unlockImpl" ref="82ec5566379a4c76fea8b68d55ee9d6f" args="(void)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::HardwareBuffer::unlockImpl           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [protected, pure virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal implementation of <a class="el" href="classOgre_1_1HardwareBuffer.html#64ddd429ff2c8ac4f0cca5decb5c6757" title="Releases the lock on this buffer.">unlock()</a>. 
<p>

<p>Implemented in <a class="el" href="classOgre_1_1DefaultHardwareVertexBuffer.html#af306e33639147e7ccbdd2c3b899ea07">Ogre::DefaultHardwareVertexBuffer</a>, and <a class="el" href="classOgre_1_1DefaultHardwareIndexBuffer.html#5d2c3465f93214d1035ac698df6f4a65">Ogre::DefaultHardwareIndexBuffer</a>.</p>

</div>
</div><p>
<a class="anchor" name="93b204642190e611bc226ea08d29160e"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::lock" ref="93b204642190e611bc226ea08d29160e" args="(LockOptions options)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* Ogre::HardwareBuffer::lock           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareBuffer.html#ac34930556f611928ec9157c04bd1b0f">LockOptions</a>&nbsp;</td>
          <td class="paramname"> <em>options</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Lock the entire buffer for (potentially) reading / writing. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>options</em>&nbsp;</td><td>Locking options </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>Pointer to the locked memory </dd></dl>

<p>Definition at line <a class="el" href="OgreHardwareBuffer_8h-source.html#l00205">205</a> of file <a class="el" href="OgreHardwareBuffer_8h-source.html">OgreHardwareBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="64ddd429ff2c8ac4f0cca5decb5c6757"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::unlock" ref="64ddd429ff2c8ac4f0cca5decb5c6757" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::HardwareBuffer::unlock           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Releases the lock on this buffer. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Locking and unlocking a buffer can, in some rare circumstances such as switching video modes whilst the buffer is locked, corrupt the contents of a buffer. This is pretty rare, but if it occurs, this method will throw an exception, meaning you must re-upload the data. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>Note that using the 'read' and 'write' forms of updating the buffer does not suffer from this problem, so if you want to be 100% sure your data will not be lost, use the 'read' and 'write' forms instead. </dd></dl>

<p>Reimplemented in <a class="el" href="classOgre_1_1DefaultHardwareVertexBuffer.html#f532954d6a6a748a654446feb428fbd0">Ogre::DefaultHardwareVertexBuffer</a>, and <a class="el" href="classOgre_1_1DefaultHardwareIndexBuffer.html#99e0bdf70d975699bffaf987a4616b3e">Ogre::DefaultHardwareIndexBuffer</a>.</p>

<p>Definition at line <a class="el" href="OgreHardwareBuffer_8h-source.html#l00221">221</a> of file <a class="el" href="OgreHardwareBuffer_8h-source.html">OgreHardwareBuffer.h</a>.</p>

<p>Referenced by <a class="el" href="OgreHardwareBuffer_8h-source.html#l00269">Ogre::HardwareBuffer::copyData()</a>.</p>

</div>
</div><p>
<a class="anchor" name="721891f0c0bd391dd5848c8a585ba054"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::copyData" ref="721891f0c0bd391dd5848c8a585ba054" args="(HardwareBuffer &amp;srcBuffer, size_t srcOffset, size_t dstOffset, size_t length, bool discardWholeBuffer=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::HardwareBuffer::copyData           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareBuffer.html">HardwareBuffer</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>srcBuffer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>srcOffset</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>dstOffset</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>length</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>discardWholeBuffer</em> = <code>false</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Copy data from another buffer into this one. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Note that the source buffer must not be created with the usage HBU_WRITE_ONLY otherwise this will fail. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>srcBuffer</em>&nbsp;</td><td>The buffer from which to read the copied data </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>srcOffset</em>&nbsp;</td><td>Offset in the source buffer at which to start reading </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>dstOffset</em>&nbsp;</td><td>Offset in the destination buffer to start writing </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>length</em>&nbsp;</td><td>Length of the data to copy, in bytes. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>discardWholeBuffer</em>&nbsp;</td><td>If true, will discard the entire contents of this buffer before copying </td></tr>
  </table>
</dl>

<p>Definition at line <a class="el" href="OgreHardwareBuffer_8h-source.html#l00269">269</a> of file <a class="el" href="OgreHardwareBuffer_8h-source.html">OgreHardwareBuffer.h</a>.</p>

<p>References <a class="el" href="OgreHardwareBuffer_8h-source.html#l00175">Ogre::HardwareBuffer::lock()</a>, and <a class="el" href="OgreHardwareBuffer_8h-source.html#l00221">Ogre::HardwareBuffer::unlock()</a>.</p>

</div>
</div><p>
<a class="anchor" name="344c52f2214eaff097d5fbc390e7684b"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::_updateFromShadow" ref="344c52f2214eaff097d5fbc390e7684b" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::HardwareBuffer::_updateFromShadow           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Updates the real buffer from the shadow buffer, if required. 
<p>

<p>Definition at line <a class="el" href="OgreHardwareBuffer_8h-source.html#l00279">279</a> of file <a class="el" href="OgreHardwareBuffer_8h-source.html">OgreHardwareBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="1b1b5faf06139040824fd989d0b279f8"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::getSizeInBytes" ref="1b1b5faf06139040824fd989d0b279f8" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t Ogre::HardwareBuffer::getSizeInBytes           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the size of this buffer in bytes. 
<p>

<p>Definition at line <a class="el" href="OgreHardwareBuffer_8h-source.html#l00304">304</a> of file <a class="el" href="OgreHardwareBuffer_8h-source.html">OgreHardwareBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="0e00770f5e9395e41b6520be8421a6c8"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::getUsage" ref="0e00770f5e9395e41b6520be8421a6c8" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630">Usage</a> Ogre::HardwareBuffer::getUsage           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the Usage flags with which this buffer was created. 
<p>

<p>Definition at line <a class="el" href="OgreHardwareBuffer_8h-source.html#l00306">306</a> of file <a class="el" href="OgreHardwareBuffer_8h-source.html">OgreHardwareBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="61086322fba08abadf4fe6734a7c70f7"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::isSystemMemory" ref="61086322fba08abadf4fe6734a7c70f7" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::HardwareBuffer::isSystemMemory           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns whether this buffer is held in system memory. 
<p>

<p>Definition at line <a class="el" href="OgreHardwareBuffer_8h-source.html#l00308">308</a> of file <a class="el" href="OgreHardwareBuffer_8h-source.html">OgreHardwareBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="d523887cfaa6abe48dd494a3ea06805a"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::hasShadowBuffer" ref="d523887cfaa6abe48dd494a3ea06805a" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::HardwareBuffer::hasShadowBuffer           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns whether this buffer has a system memory shadow for quicker reading. 
<p>

<p>Definition at line <a class="el" href="OgreHardwareBuffer_8h-source.html#l00310">310</a> of file <a class="el" href="OgreHardwareBuffer_8h-source.html">OgreHardwareBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="3d5a62cbd76fc2ecd4e1a540bac5f9bc"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::isLocked" ref="3d5a62cbd76fc2ecd4e1a540bac5f9bc" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::HardwareBuffer::isLocked           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns whether or not this buffer is currently locked. 
<p>

<p>Definition at line <a class="el" href="OgreHardwareBuffer_8h-source.html#l00312">312</a> of file <a class="el" href="OgreHardwareBuffer_8h-source.html">OgreHardwareBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="688e1be4a913099ce5e06172771e2d45"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::suppressHardwareUpdate" ref="688e1be4a913099ce5e06172771e2d45" args="(bool suppress)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::HardwareBuffer::suppressHardwareUpdate           </td>
          <td>(</td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>suppress</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<a class="el" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a> true to suppress hardware upload of shadow buffer changes. 
<p>

<p>Definition at line <a class="el" href="OgreHardwareBuffer_8h-source.html#l00316">316</a> of file <a class="el" href="OgreHardwareBuffer_8h-source.html">OgreHardwareBuffer.h</a>.</p>

</div>
</div><p>
<hr><h2>Friends And Related Function Documentation</h2>
<a class="anchor" name="2548fc9744f5e43e0276d5627ca178de"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::RenderTexture" ref="2548fc9744f5e43e0276d5627ca178de" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">friend class <a class="el" href="classOgre_1_1RenderTexture.html">RenderTexture</a><code> [friend]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwarePixelBuffer_8h-source.html#l00073">73</a> of file <a class="el" href="OgreHardwarePixelBuffer_8h-source.html">OgreHardwarePixelBuffer.h</a>.</p>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="e466eb08ea0efefbf95ad43a86a32b87"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::mWidth" ref="e466eb08ea0efefbf95ad43a86a32b87" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1HardwarePixelBuffer.html#e466eb08ea0efefbf95ad43a86a32b87">Ogre::HardwarePixelBuffer::mWidth</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwarePixelBuffer_8h-source.html#l00051">51</a> of file <a class="el" href="OgreHardwarePixelBuffer_8h-source.html">OgreHardwarePixelBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="4522dfa65baed807835c35a5b550148a"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::mHeight" ref="4522dfa65baed807835c35a5b550148a" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1HardwarePixelBuffer.html#4522dfa65baed807835c35a5b550148a">Ogre::HardwarePixelBuffer::mHeight</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwarePixelBuffer_8h-source.html#l00051">51</a> of file <a class="el" href="OgreHardwarePixelBuffer_8h-source.html">OgreHardwarePixelBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="65904db26e2e488f9a5648159dab0cdd"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::mDepth" ref="65904db26e2e488f9a5648159dab0cdd" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1HardwarePixelBuffer.html#65904db26e2e488f9a5648159dab0cdd">Ogre::HardwarePixelBuffer::mDepth</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwarePixelBuffer_8h-source.html#l00051">51</a> of file <a class="el" href="OgreHardwarePixelBuffer_8h-source.html">OgreHardwarePixelBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="0a0a98e600dfa4b15778b6bcb30acb70"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::mRowPitch" ref="0a0a98e600dfa4b15778b6bcb30acb70" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1HardwarePixelBuffer.html#0a0a98e600dfa4b15778b6bcb30acb70">Ogre::HardwarePixelBuffer::mRowPitch</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwarePixelBuffer_8h-source.html#l00053">53</a> of file <a class="el" href="OgreHardwarePixelBuffer_8h-source.html">OgreHardwarePixelBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="cae5b713a65e3d0d5881ae02b3318d34"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::mSlicePitch" ref="cae5b713a65e3d0d5881ae02b3318d34" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1HardwarePixelBuffer.html#cae5b713a65e3d0d5881ae02b3318d34">Ogre::HardwarePixelBuffer::mSlicePitch</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwarePixelBuffer_8h-source.html#l00053">53</a> of file <a class="el" href="OgreHardwarePixelBuffer_8h-source.html">OgreHardwarePixelBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="715786c17620c4705b5caefa6b2cb2df"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::mFormat" ref="715786c17620c4705b5caefa6b2cb2df" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> <a class="el" href="classOgre_1_1HardwarePixelBuffer.html#715786c17620c4705b5caefa6b2cb2df">Ogre::HardwarePixelBuffer::mFormat</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwarePixelBuffer_8h-source.html#l00055">55</a> of file <a class="el" href="OgreHardwarePixelBuffer_8h-source.html">OgreHardwarePixelBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="811656bfdacc1339fcba481c4bd8f6d1"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::mCurrentLock" ref="811656bfdacc1339fcba481c4bd8f6d1" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1PixelBox.html">PixelBox</a> <a class="el" href="classOgre_1_1HardwarePixelBuffer.html#811656bfdacc1339fcba481c4bd8f6d1">Ogre::HardwarePixelBuffer::mCurrentLock</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwarePixelBuffer_8h-source.html#l00057">57</a> of file <a class="el" href="OgreHardwarePixelBuffer_8h-source.html">OgreHardwarePixelBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="a8fecea9221ffacaae2f1fdea38558da"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::mSizeInBytes" ref="a8fecea9221ffacaae2f1fdea38558da" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1HardwareBuffer.html#a8fecea9221ffacaae2f1fdea38558da">Ogre::HardwareBuffer::mSizeInBytes</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwareBuffer_8h-source.html#l00135">135</a> of file <a class="el" href="OgreHardwareBuffer_8h-source.html">OgreHardwareBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="2eb83f024781415a7fefb31f65a255c2"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::mUsage" ref="2eb83f024781415a7fefb31f65a255c2" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1HardwareBuffer.html#e51f5970d879af736e4cf53e1ec46630">Usage</a> <a class="el" href="classOgre_1_1HardwareBuffer.html#2eb83f024781415a7fefb31f65a255c2">Ogre::HardwareBuffer::mUsage</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwareBuffer_8h-source.html#l00136">136</a> of file <a class="el" href="OgreHardwareBuffer_8h-source.html">OgreHardwareBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="25edb91791e48a7cc9ba2fb05f11bd33"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::mIsLocked" ref="25edb91791e48a7cc9ba2fb05f11bd33" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1HardwareBuffer.html#25edb91791e48a7cc9ba2fb05f11bd33">Ogre::HardwareBuffer::mIsLocked</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwareBuffer_8h-source.html#l00137">137</a> of file <a class="el" href="OgreHardwareBuffer_8h-source.html">OgreHardwareBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="272cf9751affd73ea03930153357930b"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::mLockStart" ref="272cf9751affd73ea03930153357930b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1HardwareBuffer.html#272cf9751affd73ea03930153357930b">Ogre::HardwareBuffer::mLockStart</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwareBuffer_8h-source.html#l00138">138</a> of file <a class="el" href="OgreHardwareBuffer_8h-source.html">OgreHardwareBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="c96a7a04f4e29d8d00117a80d9a1c9a0"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::mLockSize" ref="c96a7a04f4e29d8d00117a80d9a1c9a0" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1HardwareBuffer.html#c96a7a04f4e29d8d00117a80d9a1c9a0">Ogre::HardwareBuffer::mLockSize</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwareBuffer_8h-source.html#l00139">139</a> of file <a class="el" href="OgreHardwareBuffer_8h-source.html">OgreHardwareBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="f97b321278124803d13b700a46657ecb"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::mSystemMemory" ref="f97b321278124803d13b700a46657ecb" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1HardwareBuffer.html#f97b321278124803d13b700a46657ecb">Ogre::HardwareBuffer::mSystemMemory</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwareBuffer_8h-source.html#l00140">140</a> of file <a class="el" href="OgreHardwareBuffer_8h-source.html">OgreHardwareBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="2caed02d4c9ad400d020ea8b0b24adf4"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::mUseShadowBuffer" ref="2caed02d4c9ad400d020ea8b0b24adf4" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1HardwareBuffer.html#2caed02d4c9ad400d020ea8b0b24adf4">Ogre::HardwareBuffer::mUseShadowBuffer</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwareBuffer_8h-source.html#l00141">141</a> of file <a class="el" href="OgreHardwareBuffer_8h-source.html">OgreHardwareBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="01ef9e872aec8bb74b75be1aff787c8f"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::mpShadowBuffer" ref="01ef9e872aec8bb74b75be1aff787c8f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1HardwareBuffer.html">HardwareBuffer</a>* <a class="el" href="classOgre_1_1HardwareBuffer.html#01ef9e872aec8bb74b75be1aff787c8f">Ogre::HardwareBuffer::mpShadowBuffer</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwareBuffer_8h-source.html#l00142">142</a> of file <a class="el" href="OgreHardwareBuffer_8h-source.html">OgreHardwareBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="68127e87e132304c7655df554a82110c"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::mShadowUpdated" ref="68127e87e132304c7655df554a82110c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1HardwareBuffer.html#68127e87e132304c7655df554a82110c">Ogre::HardwareBuffer::mShadowUpdated</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwareBuffer_8h-source.html#l00143">143</a> of file <a class="el" href="OgreHardwareBuffer_8h-source.html">OgreHardwareBuffer.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="47e53af2e87624c42ab934766bf65fca"></a><!-- doxytag: member="Ogre::HardwarePixelBuffer::mSuppressHardwareUpdate" ref="47e53af2e87624c42ab934766bf65fca" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1HardwareBuffer.html#47e53af2e87624c42ab934766bf65fca">Ogre::HardwareBuffer::mSuppressHardwareUpdate</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreHardwareBuffer_8h-source.html#l00144">144</a> of file <a class="el" href="OgreHardwareBuffer_8h-source.html">OgreHardwareBuffer.h</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreHardwarePixelBuffer_8h-source.html">OgreHardwarePixelBuffer.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:49:57 2008
</p>
</body>
</html>
